var gulp = require('gulp');

var bower = require('bower');
var less = require('gulp-less');
var webserver = require('gulp-webserver');

var config = {
    deploy: false
};


gulp.task('bower', function(cb) {
    bower.commands.install().on('log', function(result) {
        console.log(result.message);
    }).on('error', function(result) {
        cb(result);
    }).on('end', function(result) {
        cb();
    });
});


gulp.task('less', ['bower'], function () {
    var font_path = config.deploy ? '"/static/vendor/bootstrap/fonts/"' : '"../bower_components/bootstrap/fonts/"';
    return gulp.src(
        'themes/*.less'
    ).pipe(
        less({
            strictMath: true,
            paths: ['source', 'bower_components'],
            modifyVars: {
                'icon-font-path': font_path
            }
        })
    ).pipe(
        gulp.dest('dist')
    );
});


gulp.task('dev', ['less'], function() {
    gulp.watch('**/*.less', ['less']);
    return gulp.src(
        '.'
    ).pipe(
        webserver({
            livereload: true,
            directoryListing: true,
            open: '/sandbox/'
        })
    );
});

gulp.task('set-deploy', function() {
    config.deploy = true;
});


gulp.task('default', ['set-deploy', 'less']);
